//
//  general.cpp
//  PS
//
//  Created by Bernard van Gastel on 22-11-11.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#include "general.h"

// The number of destinations printed per resource
int MAX_DESTS_PER_RESOURCE = 10;


bool MIN_DL_NOT_NEC = false;
bool VERBOSE = false;
bool DO_NOT_CHK_R_OF_POS_DL = false;
bool REPORT180 = false;
bool SMT = false;
bool LOCAL_MINIMA = false;
bool ASSEMBLE_STATISTICS = true;
bool MINIMIZE_RESOURCES = false;
bool output = true;
bool PS = false;

void zero_list(int *list, int n) {
	int i;
	for (i=0;i<n;i++)
		list[i] = 0;
}

// see http://graphics.stanford.edu/~seander/bithacks.html
unsigned int log2alt(unsigned int v) {
    // v = 32-bit value to find the log2 of
    register unsigned int r; // result of log2(v) will go here
    register unsigned int shift;
    
    r =     (v > 0xFFFF) << 4;
    v >>= r;
    shift = (v > 0xFF  ) << 3;
    v >>= shift;
    r |= shift;
    shift = (v > 0xF   ) << 2;
    v >>= shift;
    r |= shift;
    shift = (v > 0x3   ) << 1;
    v >>= shift;
    r |= shift;
    r |= (v >> 1);
    return r;
}

long long nCr(int n, int r) {
	if(r>n) {
		assert(false);
	} 
	if(n==0 || r==0 || n==r) {
		return 1;
	}
	else {
		return lround( ((double)n/(double)(n-r)/(double)r) * exp(lgamma(n) - lgamma(n-r) - lgamma(r)));
	}
}

long long min(long long x, long long y) {
	if (x>y)
		return y;
	else
		return x;
}
